Index: krita/ui/tests/kis_prescaled_projection_test.h
===================================================================
--- krita/ui/tests/kis_prescaled_projection_test.h	(revision 1163293)
+++ krita/ui/tests/kis_prescaled_projection_test.h	(working copy)
@@ -43,8 +43,6 @@
 
     void testCreation();
 
-    void testCoordinateConversionRoundTrip();
-
     // Doesn't fail yet, but at least writes out several versions
     // of a scaled image. Make them compare with the results when
     // we're done and have everything okay for regressions
@@ -53,6 +51,8 @@
     void testScalingUndeferredSmoothing();
 
     void benchmarkUpdate();
+
+    void testScaling();
 };
 
 #endif
Index: krita/ui/tests/kis_shape_selection_test.cpp
===================================================================
--- krita/ui/tests/kis_shape_selection_test.cpp	(revision 1163293)
+++ krita/ui/tests/kis_shape_selection_test.cpp	(working copy)
@@ -35,7 +35,7 @@
 void KisShapeSelectionTest::testAddChild()
 {
     const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(new KisUndoAdapter(0), 300, 300, cs, "test");
+    KisImageSP image = new KisImage(new KisUndoAdapter(0), 300, 300, cs, "test");
 
     KisSelectionSP selection = new KisSelection();
     QVERIFY(selection->hasPixelSelection() == false);
Index: krita/ui/tests/kis_node_model_test.cpp
===================================================================
--- krita/ui/tests/kis_node_model_test.cpp	(revision 1163293)
+++ krita/ui/tests/kis_node_model_test.cpp	(working copy)
@@ -54,7 +54,7 @@
 */
 void kisnodemodel_test::testRowcount()
 {
-    KisImageWSP image = new KisImage(0, 100, 100,  KoColorSpaceRegistry::instance()->rgb8(), "testimage");
+    KisImageSP image = new KisImage(0, 100, 100,  KoColorSpaceRegistry::instance()->rgb8(), "testimage");
 
     KisNodeModel model(0);
     ModelTest(&model, this);
@@ -102,7 +102,7 @@
 */
 void kisnodemodel_test::testModelIndex()
 {
-    KisImageWSP image = new KisImage(0, 100, 100,  KoColorSpaceRegistry::instance()->rgb8(), "testimage");
+    KisImageSP image = new KisImage(0, 100, 100,  KoColorSpaceRegistry::instance()->rgb8(), "testimage");
 
     KisNodeModel model(0);
     ModelTest(&model, this);
@@ -180,7 +180,7 @@
 
 void kisnodemodel_test::testGroupLayers()
 {
-    KisImageWSP image = new KisImage(0, 100, 100,  KoColorSpaceRegistry::instance()->rgb8(), "testimage");
+    KisImageSP image = new KisImage(0, 100, 100,  KoColorSpaceRegistry::instance()->rgb8(), "testimage");
 
     KisNodeModel model(0);
     ModelTest(&model, this);
Index: krita/ui/tests/CMakeLists.txt
===================================================================
--- krita/ui/tests/CMakeLists.txt	(revision 1163293)
+++ krita/ui/tests/CMakeLists.txt	(working copy)
@@ -95,3 +95,9 @@
 set(kis_doc2_test_SRCS kis_doc2_test.cpp )
 kde4_add_unit_test(KisDoc2Test TESTNAME krita-ui-KisDoc2Test  ${kis_doc2_test_SRCS})
 target_link_libraries(KisDoc2Test  ${KDE4_KDEUI_LIBS}  komain kritaui kritaimage ${QT_QTTEST_LIBRARY})
+
+########### next target ###############
+
+set(kis_coordinates_converter_test_SRCS kis_coordinates_converter_test.cpp )
+kde4_add_unit_test(KisCoordinatesConverterTest TESTNAME krita-ui-KisCoordinatesConverterTest  ${kis_coordinates_converter_test_SRCS})
+target_link_libraries(KisCoordinatesConverterTest  ${KDE4_KDEUI_LIBS}  komain kritaui kritaimage ${QT_QTTEST_LIBRARY})
Index: krita/ui/tests/kis_prescaled_projection_test.cpp
===================================================================
--- krita/ui/tests/kis_prescaled_projection_test.cpp	(revision 1163293)
+++ krita/ui/tests/kis_prescaled_projection_test.cpp	(working copy)
@@ -37,15 +37,17 @@
 #include <kis_paint_layer.h>
 #include <kis_group_layer.h>
 
+#include "canvas/kis_coordinates_converter.h"
 #include "canvas/kis_prescaled_projection.h"
 
+#include "../../sdk/tests/testutil.h"
 
 bool KisPrescaledProjectionTest::testProjectionScenario(KisPrescaledProjection & projection,
         KoZoomHandler * viewConverter,
         const QString & name)
 {
 
-    projection.resizePrescaledImage(QSize(1000, 1000));
+    projection.notifyCanvasSizeChanged(QSize(1000, 1000));
     projection.prescaledQImage().save(name + "_prescaled_projection_01.png");
 
     viewConverter->setZoom(0.5);
@@ -88,57 +90,57 @@
     projection.preScale();
     projection.prescaledQImage().save(name + "_prescaled_projection_07.png");
 
-    projection.documentOffsetMoved(QPoint(50, 50));
+    projection.viewportMoved(QPoint(50, 50));
     projection.prescaledQImage().save(name + "_prescaled_projection_08.png");
 
-    projection.documentOffsetMoved(QPoint(100, 100));
+    projection.viewportMoved(QPoint(100, 100));
     projection.prescaledQImage().save(name + "_prescaled_projection_081.png");
 
-    projection.documentOffsetMoved(QPoint(200, 200));
+    projection.viewportMoved(QPoint(200, 200));
     projection.prescaledQImage().save(name + "_prescaled_projection_082.png");
 
-    projection.documentOffsetMoved(QPoint(250, 250));
+    projection.viewportMoved(QPoint(250, 250));
     projection.prescaledQImage().save(name + "_prescaled_projection_083.png");
 
-    projection.documentOffsetMoved(QPoint(150, 200));
+    projection.viewportMoved(QPoint(150, 200));
     projection.prescaledQImage().save(name + "_prescaled_projection_084.png");
 
-    projection.documentOffsetMoved(QPoint(100, 200));
+    projection.viewportMoved(QPoint(100, 200));
     projection.prescaledQImage().save(name + "_prescaled_projection_085.png");
 
-    projection.documentOffsetMoved(QPoint(50, 200));
+    projection.viewportMoved(QPoint(50, 200));
     projection.prescaledQImage().save(name + "_prescaled_projection_086.png");
 
-    projection.documentOffsetMoved(QPoint(0, 200));
+    projection.viewportMoved(QPoint(0, 200));
     projection.prescaledQImage().save(name + "_prescaled_projection_087.png");
 
-    projection.resizePrescaledImage(QSize(750, 750));
+    projection.notifyCanvasSizeChanged(QSize(750, 750));
     projection.prescaledQImage().save(name + "_prescaled_projection_09.png");
 
     viewConverter->setZoom(1.0);
     projection.preScale();
     projection.prescaledQImage().save(name + "_prescaled_projection_10.png");
 
-    projection.resizePrescaledImage(QSize(350, 350));
+    projection.notifyCanvasSizeChanged(QSize(350, 350));
     projection.prescaledQImage().save(name + "_prescaled_projection_11.png");
 
-    projection.documentOffsetMoved(QPoint(100, 100));
+    projection.viewportMoved(QPoint(100, 100));
     projection.prescaledQImage().save(name + "_prescaled_projection_12.png");
 
     viewConverter->setZoom(0.75);
     projection.preScale();
     projection.prescaledQImage().save(name + "_prescaled_projection_13.png");
 
-    projection.documentOffsetMoved(QPoint(10, 10));
+    projection.viewportMoved(QPoint(10, 10));
     projection.prescaledQImage().save(name + "_prescaled_projection_14.png");
 
-    projection.documentOffsetMoved(QPoint(0, 0));
+    projection.viewportMoved(QPoint(0, 0));
     projection.prescaledQImage().save(name + "_prescaled_projection_15.png");
 
-    projection.documentOffsetMoved(QPoint(10, 10));
+    projection.viewportMoved(QPoint(10, 10));
     projection.prescaledQImage().save(name + "_prescaled_projection_16.png");
 
-    projection.documentOffsetMoved(QPoint(30, 50));
+    projection.viewportMoved(QPoint(30, 50));
     projection.prescaledQImage().save(name + "_prescaled_projection_17.png");
 
     return true;
@@ -153,37 +155,6 @@
     delete prescaledProjection;
 }
 
-
-void KisPrescaledProjectionTest::testCoordinateConversionRoundTrip()
-{
-    KisPrescaledProjection projection;
-
-    const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, 100, 100, cs, "projection test");
-    image->setResolution(300, 300);
-
-    KoZoomHandler * viewConverter = new KoZoomHandler();
-    viewConverter->setResolution(120, 120);
-
-    projection.setViewConverter(viewConverter);
-    projection.setImage(image);
-    projection.resizePrescaledImage(QSize(100, 100));
-
-    QRect viewRect = projection.viewRectFromImagePixels(QRect(0, 0, 100, 100)).toAlignedRect();
-
-    QCOMPARE(viewRect, QRect(0, 0, 40, 40));
-
-    QRect viewRect2 = projection.viewRectFromImagePixels(QRect(0, 0, 200, 200)).toAlignedRect();
-    QCOMPARE(viewRect2, QRect(0, 0, 80, 80));
-
-    QRect imageRect = projection.imageRectFromViewPortPixels(viewRect);
-    QCOMPARE(imageRect, QRect(0, 0, 100, 100));
-
-    QRect viewRect3 = projection.viewRectFromImagePixels(imageRect).toAlignedRect();
-    QCOMPARE(viewRect3, viewRect);
-}
-
-
 void KisPrescaledProjectionTest::testScalingUndeferredSmoothingPixelForPixel()
 {
     // Set up a nice image
@@ -191,7 +162,7 @@
 
     // Undo adapter not necessary
     const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, qimage.width(), qimage.height(), cs, "projection test");
+    KisImageSP image = new KisImage(0, qimage.width(), qimage.height(), cs, "projection test");
 
     // 300 dpi recalculated to pixels per point (of which there are 72
     // to the inch)
@@ -203,7 +174,11 @@
 
     KisPrescaledProjection projection;
     KoZoomHandler * viewConverter = new KoZoomHandler();
-    projection.setViewConverter(viewConverter);
+
+    KisCoordinatesConverter converter(viewConverter);
+    converter.setImage(image);
+    projection.setCoordinatesConverter(&converter);
+
     projection.setImage(image);
 
     // pixel-for-pixel, at 100% zoom
@@ -221,19 +196,23 @@
 
     // Undo adapter not necessary
     const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, qimage.width(), qimage.height(), cs, "projection test");
+    KisImageSP image = new KisImage(0, qimage.width(), qimage.height(), cs, "projection test");
 
     // 300 dpi recalculated to pixels per point (of which there are 72
     // to the inch)
-    image->setResolution(300 / 72 , 300 / 72);
+    image->setResolution(100, 100);
 
     KisPaintLayerSP layer = new KisPaintLayer(image, "test", OPACITY_OPAQUE_U8, cs);
     image->addNode(layer.data(), image->rootLayer(), 0);
     layer->paintDevice()->convertFromQImage(qimage, "");
 
     KisPrescaledProjection projection;
-    KoZoomHandler * viewConverter = new KoZoomHandler();
-    projection.setViewConverter(viewConverter);
+    KoZoomHandler *viewConverter = new KoZoomHandler();
+
+    KisCoordinatesConverter converter(viewConverter);
+    converter.setImage(image);
+    projection.setCoordinatesConverter(&converter);
+
     projection.setImage(image);
 
     testProjectionScenario(projection, viewConverter, "120dpi");
@@ -248,7 +227,7 @@
     QRect imageRect = QRect(QPoint(0,0), referenceImage.size());
 
     const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
-    KisImageWSP image = new KisImage(0, imageRect.width(), imageRect.height(), cs, "projection test");
+    KisImageSP image = new KisImage(0, imageRect.width(), imageRect.height(), cs, "projection test");
 
     // set up 300dpi
     image->setResolution(300 / 72 , 300 / 72);
@@ -261,7 +240,11 @@
 
     KoZoomHandler * viewConverter = new KoZoomHandler();
     KisPrescaledProjection projection;
-    projection.setViewConverter(viewConverter);
+
+    KisCoordinatesConverter converter(viewConverter);
+    converter.setImage(image);
+    projection.setCoordinatesConverter(&converter);
+
     projection.setImage(image);
 
     // Emulate "Use same aspect as pixels"
@@ -293,6 +276,58 @@
 
 }
 
+
+void KisPrescaledProjectionTest::testScaling()
+{
+    QImage sourceImage(QString(FILES_DATA_DIR) + QDir::separator() + "lena.png");
+
+    const KoColorSpace * cs = KoColorSpaceRegistry::instance()->rgb8();
+    KisImageSP image = new KisImage(0, sourceImage.width(), sourceImage.height(), cs, "projection test");
+    image->setResolution(100, 100);
+
+    KisPaintLayerSP layer = new KisPaintLayer(image, "test", OPACITY_OPAQUE_U8, cs);
+    layer->paintDevice()->convertFromQImage(sourceImage, "");
+
+    image->addNode(layer, image->rootLayer(), 0);
+
+
+    KoZoomHandler *zoomHandler = new KoZoomHandler();
+    zoomHandler->setResolution(100, 100);
+    zoomHandler->setZoom(1.);
+
+    KisCoordinatesConverter converter(zoomHandler);
+    converter.setImage(image);
+    converter.setCanvasWidgetSize(QSize(100,100));
+
+    KisPrescaledProjection projection;
+    projection.setCoordinatesConverter(&converter);
+    projection.setImage(image);
+
+    converter.setDocumentOffset(QPoint(100,100));
+    converter.setDocumentOrigin(QPoint(0,0));
+
+
+    projection.notifyCanvasSizeChanged(QSize(100,100));
+    projection.notifyZoomChanged();
+
+    QImage result = projection.prescaledQImage();
+    QImage reference = sourceImage.copy(QRect(100,100,100,100));
+
+    QPoint pt;
+    QVERIFY(TestUtil::compareQImages(pt, result, reference));
+
+
+    // Test scrolling
+    converter.setDocumentOffset(QPoint(150,150));
+    projection.viewportMoved(QPoint(50,50));
+
+    result = projection.prescaledQImage();
+    reference = sourceImage.copy(QRect(150,150,100,100));
+
+    QVERIFY(TestUtil::compareQImages(pt, result, reference));
+}
+
+
 QTEST_KDEMAIN(KisPrescaledProjectionTest, GUI)
 
 #include "kis_prescaled_projection_test.moc"
Index: krita/ui/tests/kis_shape_controller_test.cpp
===================================================================
--- krita/ui/tests/kis_shape_controller_test.cpp	(revision 1163293)
+++ krita/ui/tests/kis_shape_controller_test.cpp	(working copy)
@@ -47,7 +47,7 @@
     KisNameServer nameServer;
     KisShapeController shapeController(&doc, &nameServer);
 
-    KisImageWSP image = new KisImage(0, 512, 512, 0, "shape controller test");
+    KisImageSP image = new KisImage(0, 512, 512, 0, "shape controller test");
     QCOMPARE((int)image->rootLayer()->childCount(), 0);
 
     KisLayerSP layer = new KisPaintLayer(image, "test1", OPACITY_OPAQUE_U8);
@@ -69,7 +69,7 @@
     KisNameServer nameServer;
     KisShapeController shapeController(&doc, &nameServer);
 
-    KisImageWSP image = new KisImage(0, 512, 512, 0, "shape controller test");
+    KisImageSP image = new KisImage(0, 512, 512, 0, "shape controller test");
     QCOMPARE((int)image->rootLayer()->childCount(), 0);
 
     KisLayerSP layer = new KisPaintLayer(image, "test1", OPACITY_OPAQUE_U8);
@@ -107,7 +107,7 @@
     KisNameServer nameServer;
     KisShapeController shapeController(&doc, &nameServer);
 
-    KisImageWSP image = new KisImage(0, 512, 512, 0, "shape controller test");
+    KisImageSP image = new KisImage(0, 512, 512, 0, "shape controller test");
     QCOMPARE((int)image->rootLayer()->childCount(), 0);
 
     KisLayerSP layer = new KisPaintLayer(image, "test1", OPACITY_OPAQUE_U8);
Index: krita/ui/tests/kis_coordinates_converter_test.h
===================================================================
--- krita/ui/tests/kis_coordinates_converter_test.h	(revision 0)
+++ krita/ui/tests/kis_coordinates_converter_test.h	(revision 0)
@@ -0,0 +1,39 @@
+/*
+ *  Copyright (c) 2010 Dmitry Kazakov <dimula73@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+ */
+
+#ifndef KIS_COORDINATES_CONVERTER_TEST_H
+#define KIS_COORDINATES_CONVERTER_TEST_H
+
+#include <QtTest/QtTest>
+
+class KisCoordinatesConverterTest : public QObject
+{
+    Q_OBJECT
+
+private slots:
+    void testConversion();
+    void testImageCropping();
+    void testTransformations();
+    void testConsistency();
+    void testRotation();
+    void testMirroring();
+    void testMirroringCanvasBiggerThanImage();
+};
+
+#endif /* KIS_COORDINATES_CONVERTER_TEST_H */
+
Index: krita/ui/kis_painting_assistants_manager.cc
===================================================================
--- krita/ui/kis_painting_assistants_manager.cc	(revision 1163293)
+++ krita/ui/kis_painting_assistants_manager.cc	(working copy)
@@ -90,11 +90,11 @@
     d->updateAction();
 }
 
-void KisPaintingAssistantsManager::drawDecoration(QPainter& gc, const QPoint& documentOffset,  const QRect& area, const KoViewConverter &converter)
+void KisPaintingAssistantsManager::drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter)
 {
     foreach(KisPaintingAssistant* assistant, d->assistants) {
         gc.save();
-        assistant->drawAssistant(gc, documentOffset, area, converter);
+        assistant->drawAssistant(gc, updateRect, converter);
         gc.restore();
     }
 }
Index: krita/ui/CMakeLists.txt
===================================================================
--- krita/ui/CMakeLists.txt	(revision 1163293)
+++ krita/ui/CMakeLists.txt	(working copy)
@@ -21,6 +21,7 @@
     canvas/kis_canvas_widget_base.cpp 
     canvas/kis_canvas2.cpp 
     canvas/kis_canvas_decoration.cc
+    canvas/kis_coordinates_converter.cpp 
     canvas/kis_grid_manager.cpp 
     canvas/kis_grid_painter_configuration.cpp
     canvas/kis_perspective_grid_manager.cpp  
Index: krita/ui/tool/kis_tool_freehand.cc
===================================================================
--- krita/ui/tool/kis_tool_freehand.cc	(revision 1163293)
+++ krita/ui/tool/kis_tool_freehand.cc	(working copy)
@@ -655,7 +655,7 @@
 void KisToolFreehand::initPan(KoPointerEvent *event)
 {
     m_mode = PAN;
-    m_lastPosition = documentToViewport(event->point);
+    m_lastPosition = convertDocumentToWidget(event->point);
     event->accept();
     useCursor(QCursor(Qt::ClosedHandCursor));
 }
@@ -670,7 +670,7 @@
         return;
     event->accept();
 
-    QPointF actualPosition = documentToViewport(event->point);
+    QPointF actualPosition = convertDocumentToWidget(event->point);
     QPointF distance(m_lastPosition - actualPosition);
     canvas()->canvasController()->pan(distance.toPoint());
 
@@ -692,16 +692,6 @@
     event->ignore();
 }
 
-
-QPointF KisToolFreehand::documentToViewport(const QPointF &p)
-{
-    QPointF viewportPoint = canvas()->viewConverter()->documentToView(p);
-    viewportPoint += canvas()->documentOrigin();
-    viewportPoint += QPoint(canvas()->canvasController()->canvasOffsetX(),
-                            canvas()->canvasController()->canvasOffsetY());
-    return viewportPoint;
-}
-
 void KisToolFreehand::increaseBrushSize()
 {
     currentPaintOpPreset()->settings()->changePaintOpSize(1, 0);
Index: krita/ui/tool/kis_tool_freehand.h
===================================================================
--- krita/ui/tool/kis_tool_freehand.h	(revision 1163293)
+++ krita/ui/tool/kis_tool_freehand.h	(working copy)
@@ -150,7 +150,6 @@
     QThreadPool* m_executor;
 
     // for panning
-    QPointF documentToViewport(const QPointF &p);
     QPointF m_lastPosition;
     QTime m_strokeTimeMeasure;
 
Index: krita/ui/tool/kis_tool.cc
===================================================================
--- krita/ui/tool/kis_tool.cc	(revision 1163293)
+++ krita/ui/tool/kis_tool.cc	(working copy)
@@ -63,6 +63,7 @@
 
 #include "kis_canvas_resource_provider.h"
 #include "canvas/kis_canvas2.h"
+#include "kis_coordinates_converter.h"
 #include "filter/kis_filter_configuration.h"
 #include "kis_config.h"
 #include "kis_config_notifier.h"
@@ -183,6 +184,23 @@
     };
 }
 
+QPointF KisTool::widgetCenterInWidgetPixels()
+{
+    KisCanvas2 *kritaCanvas = dynamic_cast<KisCanvas2*>(canvas());
+    Q_ASSERT(kritaCanvas);
+
+    const KisCoordinatesConverter *converter = kritaCanvas->coordinatesConverter();
+    return converter->flakeToWidget(converter->flakeCenterPoint());
+}
+
+QPointF KisTool::convertDocumentToWidget(const QPointF& pt)
+{
+    KisCanvas2 *kritaCanvas = dynamic_cast<KisCanvas2*>(canvas());
+    Q_ASSERT(kritaCanvas);
+
+    return kritaCanvas->coordinatesConverter()->documentToWidget(pt);
+}
+
 QPointF KisTool::convertToPixelCoord(KoPointerEvent *e)
 {
     if (!image())
@@ -527,6 +545,7 @@
 
     if (canvasWidget) {
         canvasWidget->beginOpenGL();
+        canvasWidget->setupFlakeToWidgetTransformation();
     }
 #endif
 }
Index: krita/ui/tool/kis_tool.h
===================================================================
--- krita/ui/tool/kis_tool.h	(revision 1163293)
+++ krita/ui/tool/kis_tool.h	(working copy)
@@ -88,6 +88,9 @@
     /// reimplemented from superclass
     virtual void mouseDoubleClickEvent(KoPointerEvent *) {}  // when a krita tool is enabled, don't push double click on
 
+    QPointF widgetCenterInWidgetPixels();
+    QPointF convertDocumentToWidget(const QPointF& pt);
+
     /// Convert from native (postscript points) to image pixel
     /// coordinates.
     QPointF convertToPixelCoord(KoPointerEvent *e);
Index: libs/flake/KoToolRegistry.h
===================================================================
--- libs/flake/KoToolRegistry.h	(revision 1163293)
+++ libs/flake/KoToolRegistry.h	(working copy)
@@ -53,6 +53,7 @@
     KoToolRegistry(const KoToolRegistry&);
     KoToolRegistry operator=(const KoToolRegistry&);
     void init();
+    void registerGenericTools();
 
     class Private;
     Private *d;
Index: libs/flake/KoToolManager.cpp
===================================================================
--- libs/flake/KoToolManager.cpp	(revision 1163293)
+++ libs/flake/KoToolManager.cpp	(working copy)
@@ -27,10 +27,6 @@
 #include "KoToolProxy.h"
 #include "KoToolProxy_p.h"
 #include "KoSelection.h"
-#include "tools/KoCreatePathToolFactory.h"
-#include "tools/KoCreateShapesToolFactory.h"
-#include "tools/KoCreateShapesTool.h"
-#include "tools/KoPathToolFactory.h"
 #include "KoCanvasController.h"
 #include "KoCanvasControllerWidget.h"
 #include "KoShape.h"
@@ -41,10 +37,9 @@
 #include "KoInputDeviceHandlerRegistry.h"
 #include "KoInputDeviceHandlerEvent.h"
 #include "KoPointerEvent.h"
+#include "tools/KoCreateShapesTool.h"
 #include "tools/KoZoomTool.h"
-#include "tools/KoZoomToolFactory.h"
 #include "tools/KoPanTool.h"
-#include "tools/KoPanToolFactory.h"
 
 // Qt + kde
 #include <QWidget>
@@ -163,12 +158,6 @@
     if (tools.size() > 0)
         return;
 
-    tools.append(new ToolHelper(new KoCreatePathToolFactory(q)));
-    tools.append(new ToolHelper(new KoCreateShapesToolFactory(q)));
-    tools.append(new ToolHelper(new KoPathToolFactory(q)));
-    tools.append(new ToolHelper(new KoZoomToolFactory(q)));
-    tools.append(new ToolHelper(new KoPanToolFactory(q)));
-
     KoShapeRegistry::instance();
     KoToolRegistry *registry = KoToolRegistry::instance();
     foreach(const QString & id, registry->keys()) {
Index: libs/flake/KoToolRegistry.cpp
===================================================================
--- libs/flake/KoToolRegistry.cpp	(revision 1163293)
+++ libs/flake/KoToolRegistry.cpp	(working copy)
@@ -21,6 +21,15 @@
 #include "KoToolRegistry.h"
 #include <KGlobal>
 
+#include "tools/KoCreatePathToolFactory.h"
+#include "tools/KoCreateShapesToolFactory.h"
+#include "tools/KoCreateShapesTool.h"
+#include "tools/KoPathToolFactory.h"
+#include "tools/KoZoomTool.h"
+#include "tools/KoZoomToolFactory.h"
+#include "tools/KoPanTool.h"
+#include "tools/KoPanToolFactory.h"
+
 #include <KoPluginLoader.h>
 
 KoToolRegistry::KoToolRegistry()
@@ -39,6 +48,7 @@
     config.blacklist = "ToolPluginsDisabled";
     KoPluginLoader::instance()->load(QString::fromLatin1("KOffice/Tool"),
                                      QString::fromLatin1("[X-Flake-MinVersion] <= 0"));
+    registerGenericTools();
 }
 
 KoToolRegistry::~KoToolRegistry()
@@ -54,4 +64,13 @@
     return s_instance;
 }
 
+void KoToolRegistry::registerGenericTools()
+{
+    add(new KoCreatePathToolFactory(this));
+    add(new KoCreateShapesToolFactory(this));
+    add(new KoPathToolFactory(this));
+    add(new KoZoomToolFactory(this));
+    add(new KoPanToolFactory(this));
+}
+
 #include <KoToolRegistry.moc>
